local L = LibStub("AceLocale-3.0"):NewLocale("GlockFarmer", "enUS", true);

--Common
L["AddonTitle"] = "Glock Farmer";
L["CheckNumberError"] = "This entry must be a number";
L["EnableMove"] = "Enable Move";
L["EnableResize"] = "Enable Resize";
L["ShowAllChars"] = "Show All Characters";
L["MoreOptions"] = "More Options";

--Herbs
L["ShowAllHerbs"] = "Show All Herbs";
L["DeathBlossom"] = "Death Blossom";
L["ShowDeathBlossom"] = "Show Death Blossom";
L["NeedDeathBlossom"] = "Death Blossom Needed";
L["DeathBlossomLocation"] = "Death Blossom can be found in all the zones throughout Shadowlands.";
L["Nightshade"] = "Nightshade";
L["ShowNightshade"] = "Show Nightshade";
L["NeedNightshade"] = "Nightshade Needed";
L["NightshadeLocation"] = "Nightshade can be found in all the zones throughout Shadowlands but can be exclusively farmed from The Maw.";
L["RisingGlory"] = "Rising Glory";
L["ShowRisingGlory"] = "Show Rising Glory";
L["NeedRisingGlory"] = "Rising Glory Needed";
L["RisingGloryLocation"] = "Rising Glory can be found in Bastion.";
L["MarrowRoot"] = "Marrow Root";
L["ShowMarrowRoot"] = "Show Marrow Root";
L["NeedMarrowRoot"] = "Marrow Root Needed";
L["MarrowRootLocation"] = "Marrow Root can be found in Maldraxxus";
L["Widowbloom"] = "Widowbloom";
L["ShowWidowbloom"] = "Show Widowbloom";
L["NeedWidowbloom"] = "Widowbloom Needed";
L["WidowbloomLocation"] = "Widowbloom can be found in Revendreth";
L["VigilsTorch"] = "Vigils Torch";
L["ShowVigilsTorch"] = "Show Vigils Torch";
L["NeedVigilsTorch"] = "Vigils Torch Needed";
L["VigilsTorchLocation"] = "Vigils Torch can be found in Ardenweald";

--Fish
L["ShowsAllOre"] = "Shows All Ore";
L["LostSole"] = "Lost Sole";
L["ShowLostSole"] = "Show Lost Sole";
L["NeedLostSole"] = "Lost Sole Needed";
L["LostSoleLocation"] = "Lost Sole can be found in all the zones throughout Shadowlands.";
L["SilverPike"] = "Silvergill Pike";
L["ShowSilverPike"] = "Show Silvergill Pike";
L["NeedSilverPike"] = "Silvergill Pike Needed";
L["SilverPikeLocation"] = "Silvergill Pike can be found in Bastion.";
L["PocketBonefish"] = "Pocket Bonefish";
L["ShowPocketBonefish"] = "Show Pocket Bonefish";
L["NeedPocketBonefish"] = "Pocket Bonefish Needed";
L["PocketBonefishLocation"] = "Pocket Bonefish can be found in Maldraxxus.";
L["Iridescent"] = "Iridescent Amberjack";
L["ShowIridescent"] = "Show Pocket Bonefish";
L["NeedIridescent"] = "Pocket Bonefish Needed";
L["IridescentLocation"] = "Iridescent Amberjack can be found in Ardenweald.";
L["SpinefinPiranha"] = "Spinefin Piranha";
L["ShowSpinefinPiranha"] = "Show Spinefin Piranha";
L["NeedSpinefinPiranha"] = "Spinefin Piranha Needed";
L["SpinefinPiranhaLocation"] = "Spinefin Piranha can be found in Revendreth.";
L["Elysian"] = "Elysian Thade";
L["ShowElysian"] = "Show Elysian Thade";
L["NeedElysian"] = "Elysian Thade Needed";
L["ElysianLocation"] = "Elysian Thade can be found in all the zones throughout Shadowlands.";

--Cloth
L["ShowsAllCloth"] = "Shows All Cloth";
L["ShroudedCloth"] = "Shrouded Cloth";
L["ShowShroudedCloth"] = "Show Lost Sole";
L["NeedShroudedCloth"] = "Shrouded Cloth Needed";
L["ShroudedClothLocation"] = "Shrouded Cloth can be found in all the zones throughout Shadowlands.";
L["LightlessSilk"] = "Lightless Silk";
L["ShowLightlessSilk"] = "Show Lightless Silk";
L["NeedLightlessSilk"] = "Lightless Silk Needed";
L["LightlessSilkLocation"] = "Lightless Silk can be found in all the zones throughout Shadowlands.";

--Leather
L["ShowsAllLeather"] = "Shows All Leather";
L["Desolate"] = "Desolate Leather";
L["ShowDesolate"] = "Show Desolate Leather";
L["NeedDesolate"] = "Desolate Leather Needed";
L["DesolateLocation"] = "Desolate Leather can be found in all the zones throughout Shadowlands.";
L["PallidBone"] = "Pallid Bone";
L["ShowPallidBone"] = "Show Pallid Bone";
L["NeedPallidBone"] = "Pallid Bone Needed";
L["PallidBoneLocation"] = "Pallid Bone can be found in all the zones throughout Shadowlands.";
L["CallousHide"] = "Callous Hide";
L["ShowCallousHide"] = "Show Callous Hide";
L["NeedCallousHide"] = "Callous Hide Needed";
L["CallousHideLocation"] = "Callous Hide can be found in all the zones throughout Shadowlands.";

--Ore
L["ShowsAllFish"] = "Shows All Fish";
L["Laestrite"] = "Laestrite Ore";
L["ShowLaestrite"] = "Show Laestrite Ore";
L["NeedLaestrite"] = "Laestrite Ore Needed";
L["LaestriteLocation"] = "Laestrite Ore can be found in all the zones throughout Shadowlands.";
L["Elethium"] = "Elethium Ore";
L["ShowElethium"] = "Show Elethium Ore";
L["NeedElethium"] = "Elethium Ore Needed";
L["ElethiumLocation"] = "Elethium Ore can be found in all the zones throughout Shadowlands but can be exclusively farmed from The Maw.";
L["Solenium"] = "Solenium Ore";
L["ShowSolenium"] = "Show Solenium Ore";
L["NeedSolenium"] = "Solenium Ore Needed";
L["SoleniumLocation"] = "Solenium Ore can be found in Bastion.";
L["Oxxein"] = "Oxxein Ore";
L["ShowOxxein"] = "Show Oxxein Ore";
L["NeedOxxein"] = "Oxxein Ore Needed";
L["OxxeinLocation"] = "Oxxein Ore can be found in Maldraxxus.";
L["Phaedrum"] = "Phaedrum Ore";
L["ShowPhaedrum"] = "Show Phaedrum Ore";
L["NeedPhaedrum"] = "Phaedrum Ore Needed";
L["PhaedrumLocation"] = "Phaedrum Ore can be found in Ardenweald.";
L["Sinvyr"] = "Sinvyr Ore";
L["ShowSinvyr"] = "Show Sinvyr Ore";
L["NeedSinvyr"] = "Sinvyr Ore Needed";
L["SinvyrLocation"] = "Sinvyr Ore can be found in Revendreth.";

--Meat
L["ShowsAllMeat"] = "Shows All Meat";
L["Aethereal"] = "Aethereal Meat";
L["ShowAethereal"] = "Show Aethereal Meat";
L["NeedAethereal"] = "Aethereal Meat Needed";
L["AetherealLocation"] = "Aethereal Meat can be found in Baston where Gilded Cloudstrider spawn.";
L["CreepingCrawler"] = "Creeping Crawler Meat";
L["ShowCreepingCrawler"] = "Show Creeping Crawler Meat";
L["NeedCreepingCrawler"] = "Creeping Crawler Meat Needed";
L["CreepingCrawlerLocation"] = "Creeping Crawler Meat can be found in Maldraxxus where Sloughskin Nymph and Devouring Sloughskin spawn.";
L["RawSeraphicWing"] = "Raw Seraphic Wing";
L["ShowRawSeraphicWing"] = "Show Raw Seraphic Wing";
L["NeedRawSeraphicWing"] = "Raw Seraphic Wing Needed";
L["RawSeraphicWingLocation"] = "Raw Seraphic Wing can be found in Bastion where Anima-Starved Cloudfeather and Anima-Starved Wyrm spawn.";
L["PhantasmalHaunch"] = "Phantasmal Haunch";
L["ShowPhantasmalHaunch"] = "Show Phantasmal Haunch";
L["NeedPhantasmalHaunch"] = "Phantasmal Haunch Needed";
L["PhantasmalHaunchLocation"] = "Phantasmal Haunch can be found in Ardenweald where Gorm Raveners spawn.";
L["ShadowyShank"] = "Shadowy Shank";
L["ShowShadowyShank"] = "Show Shadowy Shank";
L["NeedShadowyShank"] = "Shadowy Shank Needed";
L["ShadowyShankLocation"] = "Phantasmal Haunch can be found in Ardenweald where Gorm Raveners spawn.";
L["TenebrousRibs"] = "Tenebrous Ribs";
L["ShowTenebrousRibs"] = "Show Tenebrous Ribs";
L["NeedTenebrousRibs"] = "Tenebrous Ribs Needed";
L["TenebrousRibsLocation"] = "Tenebrous Ribs can be found in Ardenweald where Runestags and Juvenile Runedeer spawn.";
